﻿-- Author      : jjacob
-- Create Date : 10/19/2008 5:28:33 PM
-- Updated	   : 07/05/2009 

function XP_timer_OnLoad()
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_MONEY");

	SLASH_XPTIMERRESET1 = "/xp_timer_reset"
	SlashCmdList["XPTIMERRESET"] = XP_timer_reset;
    --to toggle the timer displayed with every kill
    SLASH_XPTIMEROFF1 = "/xp_timer_off"
	SlashCmdList["XPTIMEROFF"] = XP_timer_Off;
    SLASH_XPTIMERON1 = "/xp_timer_on"
	SlashCmdList["XPTIMERON"] = XP_timer_On;
    SLASH_XPTIMER1 = "/xpt";
	SLASH_XPTIMER2 = "/xp_timer";
	SlashCmdList["XPTIMER"] = XP_timer_display;
	SLASH_CASHTIMER1 = "/ct";
	SLASH_CASHTIMER2 = "/cash_timer";
	SlashCmdList["CASHTIMER"] = cash_timer_display;
	SLASH_CASHTIMERRESET1 = "/ct_reset";
	SlashCmdList["CASHTIMERRESET"] = cash_timer_reset;
end

function XP_timer_OnEvent()
	if (event == "PLAYER_LOGIN") then
		XP_timer_reset();
		cash_timer_setup();
	end 
	if (event == "PLAYER_XP_UPDATE") then
		local xp_timer_xp_cur = UnitXP("player");
		local xp_timer_xp_diff_old = xp_timer_xp_diff;
		xp_timer_xp_diff = xp_timer_xp_cur - xp_timer_old_xp;
		if (xp_timer_xp_diff < 0) then -- lvled up
			xp_timer_xp_diff = xp_timer_xp_diff_old; -- assume that the expgained was the same as before, this will quickly factor out over time.
		end
		--track total xp gained
		xp_timer_xp_gained = xp_timer_xp_gained + xp_timer_xp_diff;
		-- find amount of time playing
		local xp_timer_time_diff = GetTime() - xp_timer_start_time;
		if (xp_timer_time_diff > 0) then -- incase xp is gained instantly upon login
			if (show_time_on_xp) then
                local xp_timer_xp_per_second = xp_timer_xp_gained / xp_timer_time_diff;
			    DEFAULT_CHAT_FRAME:AddMessage("Time to next level: "..to_hms_string((UnitXPMax("player") - xp_timer_xp_cur) / xp_timer_xp_per_second),0.18,0.3,0.29);
            end
			xp_timer_old_xp = xp_timer_xp_cur;
		end -- time has passed:
	end -- end Player XP update
	if (event == "PLAYER_MONEY") then
		local current_time = GetTime();
		--DEFAULT_CHAT_FRAME:AddMessage("You where paid at "..to_hms_string(current_time));
		cash_time_diff = current_time - cash_time_last_paid ;
		cash_time_last_paid = current_time;
		cash_running_time = cash_running_time +cash_time_diff;
		--DEFAULT_CHAT_FRAME:AddMessage("You where last paid "..to_hms_string(cash_time_diff).." ago.");
		local current_cash = GetMoney();
		cash_diff = current_cash - cash_last_known ;
		cash_last_known = current_cash;
		--DEFAULT_CHAT_FRAME:AddMessage("You just made "..to_gsc_string(cash_diff).." copper.");
		--DEFAULT_CHAT_FRAME:AddMessage("You have "..to_gsc_string(GetMoney()).." copper.");
		if (cash_values_array[cash_running_time] == nil) then
			cash_values_array[cash_running_time] = cash_diff
		else
			cash_values_array[cash_running_time] = cash_values_array[cash_running_time]+ cash_diff;
		end
		--DEFAULT_CHAT_FRAME:AddMessage("You recieved "..to_gsc_string(cash_values_array[cash_running_time]).." copper this second.");
	end
end

function XP_timer_reset()
	DEFAULT_CHAT_FRAME:AddMessage("XP Timer reset");
	xp_timer_old_xp = UnitXP("player");
	xp_timer_start_time = GetTime(); 
	xp_timer_xp_gained = 1;
	xp_timer_xp_diff = 1;
    if (show_time_on_xp == nil) then
        show_time_on_xp = true;
    end
end


function XP_timer_Off()
    show_time_on_xp = false;
    DEFAULT_CHAT_FRAME:AddMessage("Time will not be shown with each kill type /xp_timer_on to reenable or /xpt to view once");
end


function XP_timer_On()
    show_time_on_xp = true;
    DEFAULT_CHAT_FRAME:AddMessage("Time will be shown with each kill type /xpt to view more information");
end



function XP_timer_display()
	local xp_timer_time_diff = GetTime() - xp_timer_start_time;
	DEFAULT_CHAT_FRAME:AddMessage("Time Logged IN: "..to_hms_string(xp_timer_time_diff));
	DEFAULT_CHAT_FRAME:AddMessage("XP Gained total: "..xp_timer_xp_gained);
	DEFAULT_CHAT_FRAME:AddMessage("XP Gained: "..xp_timer_xp_diff);
	local xp_timer_xp_per_second = xp_timer_xp_gained / xp_timer_time_diff;
	DEFAULT_CHAT_FRAME:AddMessage("XP per second: "..xp_timer_xp_per_second);
	local xp_timer_xp_cur = UnitXP("player");
	local xp_timer_kills_to_lvl = math.ceil((UnitXPMax("player") - xp_timer_xp_cur) / xp_timer_xp_diff);
	DEFAULT_CHAT_FRAME:AddMessage("Kills to next level: "..xp_timer_kills_to_lvl);
	DEFAULT_CHAT_FRAME:AddMessage("Time to next level: "..to_hms_string((UnitXPMax("player") - xp_timer_xp_cur) / xp_timer_xp_per_second));
end

function cash_timer_setup()
	DEFAULT_CHAT_FRAME:AddMessage("Cash Timer setup");
	if (cash_values_array == nil) then
		cash_values_array  = {}; -- first run on install
	end
	if (cash_running_time == nil) then
		cash_running_time = 0; -- first run on install
	end
	cash_last_known = GetMoney();
	cash_time_last_paid = GetTime();
	
end

function cash_timer_reset()
	DEFAULT_CHAT_FRAME:AddMessage("Cash Timer reset");
	cash_values_array  = {};
	cash_running_time = 0;
	cash_last_known = GetMoney();
	cash_time_last_paid = GetTime();
end

function cash_timer_display()
	local current_time = GetTime();
	cash_time_diff = current_time - cash_time_last_paid ;
	cash_time_last_paid = current_time;
	cash_running_time = cash_running_time + cash_time_diff;
	local cash_in_last_minute = 0;
	local cash_in_last_hour = 0;
	local cash_in_last_day = 0;
	for cash_time,cash_made in pairs(cash_values_array) do
	--DEFAULT_CHAT_FRAME:AddMessage("calculating: "..to_gsc_string(cash_made).." at "..to_hms_string(cash_time));
	 if (cash_running_time - cash_time < 300)then
		cash_in_last_minute = cash_in_last_minute + cash_made;
	 end
	 if (cash_running_time - cash_time < 3600) then 
		cash_in_last_hour = cash_in_last_hour + cash_made;		
	 end
	 if (cash_running_time - cash_time < 86400) then
		cash_in_last_day = cash_in_last_day + cash_made;
	 end
	end
	DEFAULT_CHAT_FRAME:AddMessage("Running time: "..to_hms_string(cash_running_time),1.0,0.0,0.0);
	DEFAULT_CHAT_FRAME:AddMessage("Cash in last 5 minutes: "..to_gsc_string(cash_in_last_minute),1.0,1.0,0.0);
	DEFAULT_CHAT_FRAME:AddMessage("Cash in last hour: "..to_gsc_string(cash_in_last_hour),1.0,1.0,1.0);
	DEFAULT_CHAT_FRAME:AddMessage("Cash in last day: "..to_gsc_string(cash_in_last_day),0.0,0.0,1.0);
end

function to_hms(seconds)
  hours = math.floor (seconds / 3600);
  seconds = seconds - (hours * 3600);
  minutes = math.floor (seconds / 60);
  seconds = math.floor (seconds - (minutes * 60));
  return hours,minutes,seconds;
end --to_hms

function to_hms_string(seconds)
  return string.format("%d:%.2d:%.2d", to_hms(seconds));
end --to_hms_string


function to_gsc(copper)
  gold = math.floor (copper / 10000);
  copper = copper - (gold * 10000);
  silver = math.floor (copper / 100);
  copper = math.floor (copper - (silver * 100));
  return gold,silver,copper;
end --to_hms

function to_gsc_string(copper)
  return string.format("%dG %dS %dC", to_gsc(copper));
end